'37_in_1 osnovni digitalni i analogni ulazi/izlazi

$regfile = "m328pdef.dat"
$crystal = 16000000
$hwstack = 20
$swstack = 20
$framesize = 80

Dim T_counter As Byte , Flag#12#13 As Byte
Dim Pin#2_new As Bit , Pin#2_old As Bit
Dim Adc_value As Word , Adc_value_old As Word

Config Clockdiv = 1

$include "Arduino_pins.sub"                                 'include Arduino pin definitions

Config Arduino_pin#2 = Input
Arduino_port#2 = 1

Config Arduino_pin#12 = Output
Config Arduino_pin#13 = Output

Arduino_port#12 = 0
Arduino_port#13 = 0

Config Adc = Single , Prescaler = Auto , Reference = Avcc
Config Timer2 = Pwm , Prescale = 64 , Compare_a_pwm = Clear_up
Compare2a = 0

Config Arduino_pin#7 = Input
Arduino_port#7 = 1

Flag#12#13 = 1
For T_counter = 1 To 100
  If Arduino_pin#7 = 0 Then Flag#12#13 = 0
  Waitms 10
Next

Print "37_in_1 demo program 3"
Print "#2 = digital input"
Print "#A0 = analog input"
If Flag#12#13 = 1 Then
  Print "#12, #13 = digital output"
End If
Print "#11 = PWM (analog) output"
Print

Pin#2_new = Arduino_pin#2
Pin#2_old = Pin#2_new
If Flag#12#13 = 1 Then
  Arduino_port#12 = Pin#2_new
  Arduino_port#13 = Not Pin#2_new
End If
Print "Input pin 2: " ; Pin#2_new
Print

Do
  Pin#2_new = Arduino_pin#2
  If Pin#2_new <> Pin#2_old Then
    If Flag#12#13 = 1 Then
      Arduino_port#12 = Pin#2_new
      Arduino_port#13 = Not Pin#2_new
    End If
    Print "Input pin 2: " ; Pin#2_old ; "->" ; Pin#2_new
    Pin#2_old = Pin#2_new
  End If
  Adc_value = Getadc(0)
  If Adc_value <> Adc_value_old Then
    Print "Analog pin 0: " ; Adc_value
    Adc_value_old = Adc_value
  End If
  Shift Adc_value , Right , 2
  Compare2a = Adc_value
  Waitms 100
Loop

End